
/*
    claimed - Claimed score
    Copyright (C) 2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#include "osdep.h"
#include "debug.h"
#include "main.h"
#include "compare.h"
#include "claimed.h"

void make_claimed(uint8_t band, char *band_str, uint8_t categ, FILE * htm, 
        float maxpwr, int ignunkpwr){

	char s[10], asl[10], pwr[50];
	struct CALL_INFO *c, **c2;
	int num = 0, i = 0;
	char loc[7], *callspace;
	char odx_call[SIZE_CALL + 1];
	int odx_QRB, band_freq;

	DEBUG_FUNC("make_err_files");
	
    // search for number of stations in category
    for (c = first_call[band]; c; c = c->next){
        if (c->pwr > maxpwr) continue;
        if (!ignunkpwr && c->pwr == 0.0) continue;

		if (c->categ == categ)
			num++;
	}

	if (!num)
		return;

	printf("+ Generating claimed of %s, %s: ", band_str,
		   categs[categ].name);
	
    fprintf(htm,
			"<tt><font face=\"Arial CE\" size=5>Category: <i>%s, %s</i></font></tt><br><br>\n",
			band_str, categs[categ].name);
	fprintf(htm, "<table BORDER BGCOLOR=\"#ffffff\">\n");
///
	fprintf(htm, "<tr>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">Pl.</font></b></td>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">Call</font></b></td>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">Score</font></b></td>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">QSO</font></b></td>\n");
	fprintf(htm,
			"<td><b><font face=\"Arial CE\">Locator</font></b></td>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">ASL</font></b></td>\n");
/*	fprintf(htm, "<td><b><font face=\"Arial CE\">ODX</font></b></td>\n");
	fprintf(htm, "<td><b><font face=\"Arial CE\">QRB</font></b></td>\n");*/
	fprintf(htm, "<td><b><font face=\"Arial CE\">Power</font></b></td>\n");
	fprintf(htm,
			"<td><b><font face=\"Arial CE\">Antenna</font></b></td>\n");
	fprintf(htm, "</tr>\n");
    
    ///
	c2 = (struct CALL_INFO **) malloc(num * sizeof(c));
        
	
    for (c = first_call[band]; c; c = c->next){
        if (c->pwr > maxpwr) continue;
        if (!ignunkpwr && c->pwr == 0.0) continue;

		if (c->categ == categ) {
			c2[i] = c;
			i++;
		}
	}
	
	qsort(c2, num, sizeof(c), compare_claimed_fcn);
	
    for (i = 0; i < num; i++) {
		num2loc(c2[i]->loc, loc);
        sprintf(s, "%i.", i + 1);
		
        if (strlen(s) < 4)
			strcat(s, space + strlen(space) + strlen(s) - 4);
		if (strlen(c2[i]->call) < 10)
			callspace = space + strlen(space) + strlen(c2[i]->call) - 10;
		else
			callspace = strchr(space, 0);

		if (c2[i]->asl)
			sprintf(asl, "%4i", c2[i]->asl);
		else
			strcpy(asl, "   ?");

		if (c2[i]->pwr)
			float_print(c2[i]->pwr, pwr);
        else
			strcpy(pwr, "   ?W");

		if (!*c2[i]->ant)
			strcpy(c2[i]->ant, "?");

		*odx_call = '\0';
		odx_QRB = 0;

		if (!c2[i]->odx) {
			strcpy(odx_call, "NONE");
			odx_QRB = 0;
		} else {
			strcpy(odx_call, c2[i]->odx->r_call->call);
			odx_QRB = c2[i]->odx->QRB;
		}
		
        fprintf(htm, "<tr>\n");
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%i.</font></b></td>\n",
				i + 1);
		fprintf(htm,
				"<td><b><font face=\"Arial CE\"><a href=\"%s\" target=\"_blank\">%s</a></font></b></td>\n",
				c2[i]->filename_err + strlen(cfg_epath) + 1, c2[i]->call);
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%i</font></b></td>\n",
				c2[i]->score_claimed);
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%i</font></b></td>\n",
				c2[i]->qsos);
		fprintf(htm,
				"<td><b><font face=\"Arial CE\">%s</font></b></td>\n", loc);
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%s</font></b></td>\n",
				asl);
/*		fprintf(htm,
				"<td><b><font face=\"Arial CE\">%s</font></b></td>\n",
				odx_call);
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%i</font></b></td>\n",
				odx_QRB);*/
		fprintf(htm,
				"<td align=right><b><font face=\"Arial CE\">%s</font></b></td>\n",
				pwr);
		fprintf(htm,
				"<td><b><font face=\"Arial CE\">%s</font></b></td>\n",
				c2[i]->ant);
		fprintf(htm, "</tr>\n");

    }
	fprintf(htm, "</table><hr><br>");
	printf("%i stations\n", num);
}
